package websockets.handlers;

import io.undertow.websockets.core.BufferedTextMessage;
import io.undertow.websockets.core.WebSocketChannel;
import io.undertow.websockets.core.WebSockets;

import java.util.ArrayList;

public class CuisineWebSocketWebSocketChichatHandler extends CuisineWebSocketReceiveHandler {

    final int MAX_MESSAGES = 10;
    ArrayList<String> vMessageHistory;

    public CuisineWebSocketWebSocketChichatHandler() {
        super();
        vMessageHistory = new ArrayList<>();
    }

    protected void onFullTextMessage(WebSocketChannel iChannel, BufferedTextMessage iTextMessage) {
        String vMessageContent = iTextMessage.getData();
        if(!vMessageContent.equals("R0VU") && vMessageContent.length()>0 && vMessageContent.length()<250)
            vMessageHistory.add(vMessageContent);
        if(vMessageHistory.size() > MAX_MESSAGES)
        {
            vMessageHistory.remove(0);
        }
        StringBuilder vBuilder = new StringBuilder();
        for(String vMessage : vMessageHistory)
        {
            vBuilder.append(vMessage+"\n");
        }

        String vMessage = vBuilder.toString();
        notifyOthers(vMessage);
        WebSockets.sendText(vMessage, iChannel, null);

    }

    public void register(WebSocketChannel iChannel)
    {
        super.register(iChannel);
    }

    public void unregister(WebSocketChannel iChannel)
    {
        super.unregister(iChannel);
    }

    protected void notifyOthers(String iMessages)
    {
        for( WebSocketChannel vChannel : this.getRegisteredChannels() )
        {
            WebSockets.sendText(iMessages, vChannel,null);
        }
    }

}